diff --git a/fw/http_parser.c b/fw/http_parser.c
index 6007c9a86..f19deefa5 100644
--- a/fw/http_parser.c
+++ b/fw/http_parser.c
@@ -5953,7 +5953,7 @@ do {									\
 
 #define H2_TRY_STR_BY_REF(str, curr_st, next_st)			\
 	H2_TRY_STR_LAMBDA_BY_REF_finish(str, { }, {			\
-		goto *next_st;					\
+		goto *next_st;						\
 	}, {								\
 		parser->_i_st = curr_st;				\
 	}, next_st)
@@ -5963,42 +5963,45 @@ do {									\
  * besides, @str must be of plain @TfwStr{} type and variable @fld is
  * used (instead of hard coded header field).
  */
-#define H2_TRY_STR_3LAMBDA_fixup(str, fld, lambda1, lambda2, lambda3, curr_st, next_st) \
-	BUG_ON(!TFW_STR_PLAIN(str));					\
-	if (!chunk->data)						\
-		chunk->data = p;					\
-	__fsm_n = __try_str(fld, chunk, p, __data_remain(p),		\
-			    (str)->data, (str)->len);			\
-	do {\
-	if (__fsm_n > 0) {						\
-		if (likely(chunk->len == (str)->len)) {			\
-			lambda1;					\
-			TRY_STR_INIT();					\
-			__msg_field_fixup_pos(fld, p, __fsm_n);		\
-			__FSM_I_field_chunk_flags(fld, TFW_STR_HDR_VALUE); \
-			if (__data_off(p + __fsm_n) < len) {		\
-				p += __fsm_n;				\
-				goto next_st;				\
-			}						\
-			if (likely(fin))				\
-				lambda2;				\
-			parser->_i_st = &&next_st;			\
-			__FSM_EXIT(CSTR_POSTPONE);			\
-		}							\
-		__msg_field_fixup_pos(fld, p, __fsm_n);			\
-		__FSM_I_field_chunk_flags(fld, TFW_STR_HDR_VALUE);	\
-		if (likely(fin)) {					\
-			lambda3;					\
-		}							\
-		parser->_i_st = &&curr_st;				\
-		__FSM_EXIT(CSTR_POSTPONE);				\
-	}\
+#define H2_TRY_STR_3LAMBDA_fixup(str, fld, lambda1, lambda2, lambda3,           \
+				 curr_st, next_st)				\
+	BUG_ON(!TFW_STR_PLAIN(str));						\
+	if (!chunk->data)							\
+		chunk->data = p;						\
+	__fsm_n = __try_str(fld, chunk, p, __data_remain(p),			\
+			    (str)->data, (str)->len);				\
+	do {									\
+		if (__fsm_n > 0) {						\
+			if (likely(chunk->len == (str)->len)) {			\
+				lambda1;					\
+				TRY_STR_INIT();					\
+				__msg_field_fixup_pos(fld, p, __fsm_n);		\
+				__FSM_I_field_chunk_flags(fld, TFW_STR_HDR_VALUE); \
+				if (__data_off(p + __fsm_n) < len) {		\
+					p += __fsm_n;				\
+					goto next_st;				\
+				}						\
+				if (likely(fin))				\
+					lambda2;				\
+				parser->_i_st = &&next_st;			\
+				__FSM_EXIT(CSTR_POSTPONE);			\
+			}							\
+			__msg_field_fixup_pos(fld, p, __fsm_n);			\
+			__FSM_I_field_chunk_flags(fld, TFW_STR_HDR_VALUE);	\
+			if (likely(fin)) {					\
+				lambda3;					\
+			}							\
+			parser->_i_st = &&curr_st;				\
+			__FSM_EXIT(CSTR_POSTPONE);				\
+		}								\
 	} while (0)
 
 #define H2_TRY_STR_2LAMBDA_fixup(str, fld, lambda1, lambda2, curr_st, next_st)	\
-	H2_TRY_STR_3LAMBDA_fixup(str, fld, lambda1, lambda2, {__FSM_EXIT(CSTR_NEQ);}, curr_st, next_st)
+	H2_TRY_STR_3LAMBDA_fixup(str, fld, lambda1, lambda2,			\
+				 { __FSM_EXIT(CSTR_NEQ); },			\
+				 curr_st, next_st)
 
-#define H2_TRY_STR_LAMBDA_fixup(str, fld, lambda, curr_st, next_st)	\
+#define H2_TRY_STR_LAMBDA_fixup(str, fld, lambda, curr_st, next_st)		\
 	H2_TRY_STR_2LAMBDA_fixup(str, fld, {}, lambda, curr_st, next_st)
 
 /*
@@ -6578,9 +6581,13 @@ __h2_req_parse_content_type(TfwHttpMsg *hm, unsigned char *data, size_t len,
 		static const TfwStr s_multipart_form_data =
 			TFW_STR_STRING("multipart/form-data");
 		H2_TRY_STR_3LAMBDA_fixup(&s_multipart_form_data, &parser->hdr, {}, {
-			__set_bit(TFW_HTTP_B_CT_MULTIPART, req->flags);
-			__FSM_EXIT(CSTR_EQ);
-		}, {p += __fsm_n; break;}, I_ContTypeMediaType, I_ContTypeMaybeMultipart);
+				__set_bit(TFW_HTTP_B_CT_MULTIPART, req->flags);
+				__FSM_EXIT(CSTR_EQ);
+			}, {
+				p += __fsm_n;
+				break;
+			},
+			I_ContTypeMediaType, I_ContTypeMaybeMultipart);
 		if (chunk->len >= sizeof("multipart/") - 1) {
 			TRY_STR_INIT();
 			__FSM_I_JMP(I_ContTypeOtherSubtype);
@@ -7273,7 +7280,8 @@ do {									\
 		if (isdigit(c)) {
 			p += 1;
 			if (__data_off(p) == len && fin) {
-				parser->date.year = parser->date.year * 10 + (c - '0');
+				parser->date.year
+					= parser->date.year * 10+ (c - '0');
 				++parser->date.pos;
 				__FSM_JMP(*st[parser->date.type][parser->date.pos]);
 			}
@@ -8242,8 +8250,9 @@ tfw_h2_parse_req_hdr(unsigned char *data, unsigned long len, TfwHttpReq *req,
 		case ':':
 			p += 1;
 			if (likely(__data_off(p) < len)) {
-				T_DBG3("%s: name next, to=Req_HdrPseudo len=%lu, off=%lu\n", __func__,
-				    len, __data_off(p));
+				T_DBG3("%s: name next, to=Req_HdrPseudo"
+				       " len=%lu, off=%lu\n", __func__,
+				       len, __data_off(p));
 				__FSM_JMP(Req_HdrPseudo);
 			}
 			if (likely(!fin)) {
diff --git a/fw/t/unit/test.c b/fw/t/unit/test.c
index 0492f1bbd..6c4cc7753 100644
--- a/fw/t/unit/test.c
+++ b/fw/t/unit/test.c
@@ -110,45 +110,45 @@ test_run_all(void)
 
 	test_fail_counter = 0;
 
-//	/* Run sleeping tests first. */
-//	TEST_SUITE_RUN(cfg);
-//	TEST_SUITE_RUN(wq);
+	/* Run sleeping tests first. */
+	TEST_SUITE_RUN(cfg);
+	TEST_SUITE_RUN(wq);
 
 	kernel_fpu_begin();
 
-//	/*
-//	 * Preemption is disabled by kernel_fpu_begin(), so
-//	 * the tests can not sleep.
-//	 */
-//	TEST_SUITE_RUN(tfw_str);
-//	__fpu_schedule();
+	/*
+	 * Preemption is disabled by kernel_fpu_begin(), so
+	 * the tests can not sleep.
+	 */
+	TEST_SUITE_RUN(tfw_str);
+	__fpu_schedule();
 
-//	TEST_SUITE_RUN(mem_fast);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(mem_fast);
+	__fpu_schedule();
 
-//	TEST_SUITE_RUN(http1_parser);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(http1_parser);
+	__fpu_schedule();
 
 	TEST_SUITE_RUN(http2_parser);
 	__fpu_schedule();
 
-//	TEST_SUITE_RUN(http_match);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(http_match);
+	__fpu_schedule();
 
-//	TEST_SUITE_RUN(http_msg);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(http_msg);
+	__fpu_schedule();
 
-//	TEST_SUITE_RUN(hash);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(hash);
+	__fpu_schedule();
 
-//	TEST_SUITE_RUN(addr);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(addr);
+	__fpu_schedule();
 
-//	TEST_SUITE_RUN(hpack);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(hpack);
+	__fpu_schedule();
 
-//	TEST_SUITE_RUN(pool);
-//	__fpu_schedule();
+	TEST_SUITE_RUN(pool);
+	__fpu_schedule();
 
 	kernel_fpu_end();
 
diff --git a/fw/t/unit/test_http2_parser.c b/fw/t/unit/test_http2_parser.c
index c9917696f..26728c0c3 100644
--- a/fw/t/unit/test_http2_parser.c
+++ b/fw/t/unit/test_http2_parser.c
@@ -514,9 +514,12 @@ TEST(http2_parser, alphabets)
 		HEADER(STR("user-agent"), STR("Wget/1.13.4 (linux-gnu)\t  "));
 		HEADER(STR("accept"), STR("*/*\t "));
 		HEADER(STR("x-custom-hdr"), STR("custom header values \t  "));
-		HEADER(STR("x-forwarded-for"), STR("127.0.0.1, example.com    \t "));
-		HEADER(STR("content-type"), STR("text/html; charset=iso-8859-1  \t "));
-		HEADER(STR("cache-control"), STR("max-age=0, private, min-fresh=42 \t "));
+		HEADER(STR("x-forwarded-for"),
+		       STR("127.0.0.1, example.com    \t "));
+		HEADER(STR("content-type"),
+		       STR("text/html; charset=iso-8859-1  \t "));
+		HEADER(STR("cache-control"),
+		       STR("max-age=0, private, min-fresh=42 \t "));
 	    HEADERS_FRAME_END();
 	);
 }
@@ -572,10 +575,12 @@ TEST(http2_parser, fills_hdr_tbl_for_req)
 		HEADER(STR("Dummy7"), STR("7"));
 		HEADER(STR("Dummy8"), STR("8"));
 		HEADER(STR("Dummy9"), STR("9"));
-		HEADER(STR("cache-control"), STR("max-age=1, dummy, no-store, min-fresh=30"));
+		HEADER(STR("cache-control"),
+		       STR("max-age=1, dummy, no-store, min-fresh=30"));
 		HEADER(STR("pragma"), STR("no-cache, fooo "));
 		HEADER(STR("cookie"), STR("session=42; theme=dark"));
-		HEADER(STR("authorization"), STR("Basic QWxhZGRpbjpvcGVuIHNlc2FtZQ==\t "));
+		HEADER(STR("authorization"),
+		       STR("Basic QWxhZGRpbjpvcGVuIHNlc2FtZQ==\t "));
 	    HEADERS_FRAME_END();
 	)
 	{
@@ -1199,7 +1204,7 @@ TEST(http2_parser, accept)
 #define FOR_ACCEPT(accept_val)		__FOR_ACCEPT(accept_val, EXPECT_FALSE)
 #define FOR_ACCEPT_HTML(accept_val)	__FOR_ACCEPT(accept_val, EXPECT_TRUE)
 
-#define EXPECT_BLOCK_REQ_H2_ACCEPT(header)						\
+#define EXPECT_BLOCK_REQ_H2_ACCEPT(header)					\
 	EXPECT_BLOCK_REQ_H2(							\
 	    HEADERS_FRAME_BEGIN();						\
 		HEADER(STR(":method"), STR("GET"));				\
@@ -1216,18 +1221,18 @@ TEST(http2_parser, accept)
 	FOR_ACCEPT(HEAD ";key=\"\"");						\
 	FOR_ACCEPT(HEAD "  ; \t key=val");					\
 	FOR_ACCEPT(HEAD ";key=val;key=val");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";");						\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";;");						\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=\"");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=\"\"\"");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=\"val");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=val\"");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key==");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key =val");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";\"key\"=val");				\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key= val");					\
-	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD " key=val");					\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";");					\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";;");					\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=\"");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=\"\"\"");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=\"val");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=val\"");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key=");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key==");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key =val");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";\"key\"=val");			\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD ";key= val");				\
+	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD " key=val");				\
 	EXPECT_BLOCK_REQ_H2_ACCEPT(HEAD "key=val");
 
 	/* media-range */
@@ -1402,7 +1407,8 @@ TEST(http2_parser, host)
 			.chunks = (TfwStr []) {
 				{ .data = ":authority" , .len = 10 },
 				{ .data = "[fd42:5ca1:e3a7::1000]" , .len = 22,
-				  .flags = TFW_STR_HDR_VALUE|TFW_STR_VALUE|TFW_STR_TRAILER },
+				  .flags = TFW_STR_HDR_VALUE|TFW_STR_VALUE
+					   |TFW_STR_TRAILER },
 			},
 			.len = 32,
 			.nchunks = 2,
@@ -1421,11 +1427,13 @@ TEST(http2_parser, host)
 			.chunks = (TfwStr []) {
 				{ .data = ":authority" , .len = 10 },
 				{ .data = "[fd42:5ca1:e3a7::1000]" , .len = 22,
-				  .flags = TFW_STR_HDR_VALUE|TFW_STR_VALUE|TFW_STR_TRAILER },
+				  .flags = TFW_STR_HDR_VALUE|TFW_STR_VALUE
+					   |TFW_STR_TRAILER },
 				{ .data = ":" , .len = 1,
 				 .flags = TFW_STR_TRAILER },
 				{ .data = "65535", .len = 5,
-				  .flags = TFW_STR_HDR_VALUE|TFW_STR_VALUE|TFW_STR_TRAILER },
+				  .flags = TFW_STR_HDR_VALUE|TFW_STR_VALUE
+					   |TFW_STR_TRAILER },
 			},
 			.len = 38,
 			.nchunks = 4,
@@ -2406,14 +2414,14 @@ TEST(http2_parser, vchar)
 	)
 
 /* Tests that header is validated by ctext_vchar alphabet. */
-#define TEST_VCHAR_HEADER(header, id)				\
-	EXPECT_FOR_REQ_H2_HDR_EQ(header, VCHAR_ALPHABET, id);	\
-	EXPECT_BLOCK_REQ_H2_HDR(header, "");			\
-	EXPECT_BLOCK_REQ_H2_HDR(header, "\x08");		\
-	EXPECT_BLOCK_REQ_H2_HDR(header, "\x0B");		\
-	EXPECT_BLOCK_REQ_H2_HDR(header, "\x14");		\
-	EXPECT_BLOCK_REQ_H2_HDR(header, "\x1F");		\
-	EXPECT_BLOCK_REQ_H2_HDR(header, "\x7F");		\
+#define TEST_VCHAR_HEADER(header, id)						\
+	EXPECT_FOR_REQ_H2_HDR_EQ(header, VCHAR_ALPHABET, id);			\
+	EXPECT_BLOCK_REQ_H2_HDR(header, "");					\
+	EXPECT_BLOCK_REQ_H2_HDR(header, "\x08");				\
+	EXPECT_BLOCK_REQ_H2_HDR(header, "\x0B");				\
+	EXPECT_BLOCK_REQ_H2_HDR(header, "\x14");				\
+	EXPECT_BLOCK_REQ_H2_HDR(header, "\x1F");				\
+	EXPECT_BLOCK_REQ_H2_HDR(header, "\x7F");				\
 	EXPECT_BLOCK_REQ_H2(							\
 	    HEADERS_FRAME_BEGIN();						\
 		HEADER(STR(":method"), STR("GET"));				\
@@ -2520,6 +2528,7 @@ TEST(http2_parser, perf)
 	    HEADER(STR(":authority"), STR("example.com"));
 	HEADERS_FRAME_END();
 	request_1.size = H2_BUILDER_GET_BUF_SIZE();
+	H2_BUILDER_RESET_BUF();
 
 	H2_BUILDER_INIT();
 	H2_BUILDER_SET_BUF(request_2.data);
@@ -2531,11 +2540,15 @@ TEST(http2_parser, perf)
 	    HEADER(STR("authorization"), STR("Basic QWxhZGRpbjpvcGVuIHNlc2FtZQ=="));
 	    HEADER(STR("user-agent"), STR("Wget/1.13.4 (linux-gnu)"));
 	    HEADER(STR("if-modified-since"), STR("Sat, 29 Oct 1994 19:43:31 GMT"));
-	    HEADER(STR("x-forwarded-for"), STR("203.0.113.195,70.41.3.18,150.172.238.178"));
+	    HEADER(STR("x-forwarded-for"),
+		   STR("203.0.113.195,70.41.3.18,150.172.238.178"));
 	    HEADER(STR("cookie"), STR("session=42; theme=dark"));
-	    HEADER(STR("referer"), STR("http://[2001:0db8:11a3:09d7:1f34:8a2e:07a0:765d]:8080/cgi-bin/show.pl?entry=tempesta"));
+	    HEADER(STR("referer"),
+		   STR("http://[2001:0db8:11a3:09d7:1f34:8a2e:07a0:765d]:8080"
+		       "/cgi-bin/show.pl?entry=tempesta"));
 	HEADERS_FRAME_END();
 	request_2.size = H2_BUILDER_GET_BUF_SIZE();
+	H2_BUILDER_RESET_BUF();
 
 	/* Also test invalid request. */
 	H2_BUILDER_INIT();
@@ -2547,20 +2560,23 @@ TEST(http2_parser, perf)
 	    HEADER(STR("authority"), STR("foo.com"));
 	HEADERS_FRAME_END();
 	request_3.size = H2_BUILDER_GET_BUF_SIZE();
+	H2_BUILDER_RESET_BUF();
 
 	H2_BUILDER_INIT();
 	H2_BUILDER_SET_BUF(request_4.data);
 	HEADERS_FRAME_BEGIN();
 	    HEADER(STR(":method"), STR("GET"));
 	    HEADER(STR(":scheme"), STR("https"));
-	    HEADER(STR(":path"), STR("/https://ru.wikipedia.org/wiki/%D0%A8%D0%B0%D0"
-			       "%B1%D0%BB%D0%BE%D0%BD:%D0%9B%D0%B5%D0%BE%D0%BD"
-			       "%D0%B0%D1%80%D0%B4%D0%BE_%D0%B4%D0%B0_%D0%92%D0"
-			       "%B8%D0%BD%D1%87%D0%B8"));
+	    HEADER(STR(":path"),
+		   STR("/https://ru.wikipedia.org/wiki/%D0%A8%D0%B0%D0"
+		       "%B1%D0%BB%D0%BE%D0%BD:%D0%9B%D0%B5%D0%BE%D0%BD"
+		       "%D0%B0%D1%80%D0%B4%D0%BE_%D0%B4%D0%B0_%D0%92%D0"
+		       "%B8%D0%BD%D1%87%D0%B8"));
 	    HEADER(STR(":method"), STR("POST"));
 	    HEADER(STR(":authority"), STR("test"));
 	HEADERS_FRAME_END();
 	request_4.size = H2_BUILDER_GET_BUF_SIZE();
+	H2_BUILDER_RESET_BUF();
 
 	H2_BUILDER_INIT();
 	H2_BUILDER_SET_BUF(request_5.data);
@@ -2571,13 +2587,16 @@ TEST(http2_parser, perf)
 	    HEADER(STR(":authority"), STR("a.com"));
 	    HEADER(STR("cookie"), STR("session=42; theme=dark"));
 	    HEADER(STR("Dummy0"), STR("0"));
-	    HEADER(STR("referer"), STR("http://tempesta-tech.com:8080\r\n"
-				"/cgi-bin/show.pl?entry=tempesta"));
+	    HEADER(STR("referer"),
+		   STR("http://tempesta-tech.com:8080\r\n"
+		       "/cgi-bin/show.pl?entry=tempesta"));
 	    HEADER(STR("if-modified-since"), STR("Sat, 29 Oct 1994 19:43:31 GMT"));
-	    HEADER(STR("x-forwarded-for"), STR("203.0.113.195,70.41.3.18,150.172.238.178"));
+	    HEADER(STR("x-forwarded-for"),
+		   STR("203.0.113.195,70.41.3.18,150.172.238.178"));
 	    HEADER(STR("x-custom-hdr"), STR("custom header values"));
 	HEADERS_FRAME_END();
 	request_5.size = H2_BUILDER_GET_BUF_SIZE();
+	H2_BUILDER_RESET_BUF();
 
 	H2_BUILDER_INIT();
 	H2_BUILDER_SET_BUF(request_6.data);
@@ -2589,22 +2608,23 @@ TEST(http2_parser, perf)
 	    HEADER(STR("accept"), STR("*/*"));
 	HEADERS_FRAME_END();
 	request_6.size = H2_BUILDER_GET_BUF_SIZE();
+	H2_BUILDER_RESET_BUF();
 
 #define REQ_PERF(frames_buf)							\
-do {									\
-	test_case_parse_prepare_h2();					\
-	if (req)							\
-		test_req_free(req);					\
-	req = test_req_alloc(frames_buf.size);				\
-		req = test_req_alloc(frames_max_sz);	   \
-		conn.h2.hpack.state = 0;			   \
-		req->conn = (TfwConn*)&conn;			   \
-		req->pit.parsed_hdr = &stream.parser.hdr;	   \
-		req->stream = &stream;				   \
-		tfw_http_init_parser_req(req);			   \
-		stream.msg = (TfwMsg*)req;			   \
-		__set_bit(TFW_HTTP_B_H2, req->flags);		   \
-	tfw_h2_parse_req(req, frames_buf.data, frames_buf.size, &parsed);		\
+do {										\
+	test_case_parse_prepare_h2();						\
+	if (req)								\
+		test_req_free(req);						\
+	req = test_req_alloc(frames_buf.size);					\
+		req = test_req_alloc(frames_max_sz);				\
+		conn.h2.hpack.state = 0;					\
+		req->conn = (TfwConn*)&conn;					\
+		req->pit.parsed_hdr = &stream.parser.hdr;			\
+		req->stream = &stream;						\
+		tfw_http_init_parser_req(req);					\
+		stream.msg = (TfwMsg*)req;					\
+		__set_bit(TFW_HTTP_B_H2, req->flags);				\
+	tfw_h2_parse_req(req, frames_buf.data, frames_buf.size, &parsed);	\
 } while (0)
 
 	for (i = 0; i < 1000; ++i) {
@@ -2627,10 +2647,6 @@ do {									\
 #undef H2_BUF
 }
 
-TEST(http2_parser, work)
-{
-}
-
 TEST_SUITE(http2_parser)
 {
 	TEST_RUN(http2_parser, http2_check_important_fields);
@@ -2656,7 +2672,6 @@ TEST_SUITE(http2_parser)
 	TEST_RUN(http2_parser, method_override);
 	TEST_RUN(http2_parser, vchar);
 	TEST_RUN(http2_parser, perf);
-	TEST_RUN(http2_parser, work);
 
 	/*
 	 * Testing for correctness of redirection mark parsing (in
diff --git a/fw/t/unit/test_http_parser_common.h b/fw/t/unit/test_http_parser_common.h
index 412e2efea..dd385850f 100644
--- a/fw/t/unit/test_http_parser_common.h
+++ b/fw/t/unit/test_http_parser_common.h
@@ -40,18 +40,12 @@
 #endif
 #define EXPORT_SYMBOL(...)
 
-//#include "http_parser.h"
-//#include "http_sess.h"
-//#include "str.h"
-//#include "ss_skb.h"
-//#include "msg.h"
-//#include "http_msg.h"
-#include "http_parser.c"
-#include "http_sess.c"
-#include "str.c"
-#include "ss_skb.c"
-#include "msg.c"
-#include "http_msg.c"
+#include "http_parser.h"
+#include "http_sess.h"
+#include "str.h"
+#include "ss_skb.h"
+#include "msg.h"
+#include "http_msg.h"
 
 static const unsigned int CHUNK_SIZES[] = { 1, 2, 3, 4, 8, 16, 32, 64, 128,
                                    256, 1500, 9216, 1024*1024
@@ -140,9 +134,9 @@ static unsigned int frames_cnt = 0;
 static unsigned int frames_max_sz = 0;
 static unsigned int frames_total_sz = 0;
 
-static unsigned char frames_str_buf[3 * 1024];
-static unsigned char *frames_buf_ptr = frames_str_buf;
-static unsigned int frames_buf_capacity = sizeof(frames_str_buf);
+static unsigned char frames_str_buf[3 * 1024] __attribute__((unused));
+static unsigned char *frames_buf_ptr __attribute__((unused)) = NULL;
+static unsigned int frames_buf_capacity __attribute__((unused)) = 0;
 
 static
 unsigned int __attribute__((unused))
@@ -199,48 +193,52 @@ __data_from_RAW(char *data, size_t size)
 #define RAW(data) \
 	__data_from_RAW(data, sizeof(data))
 
-#define HEADERS_FRAME_BEGIN()				\
-do {							\
-	TfwHeaderRec temp;				\
-	unsigned int frame_sz = 0;			\
-	frames[frames_cnt].subtype = HTTP2_HEADERS\
-
-#define HEADER(name_rec, value_rec)			\
-do {							\
-	temp.name = name_rec;				\
-	temp.value = value_rec;				\
-	frame_sz += tfw_h2_encode_header(temp);		\
-	BUG_ON(frames_buf_ptr > frames_str_buf + frames_buf_capacity);	\
+#define HEADERS_FRAME_BEGIN()							\
+do {										\
+	TfwHeaderRec temp;							\
+	unsigned int frame_sz = 0;						\
+	BUG_ON(frames_cnt >= ARRAY_SIZE(frames));				\
+	frames[frames_cnt].subtype = HTTP2_HEADERS				\
+
+#define HEADER(name_rec, value_rec)						\
+do {										\
+	temp.name = name_rec;							\
+	temp.value = value_rec;							\
+	frame_sz += tfw_h2_encode_header(temp);					\
+	BUG_ON(frames_buf_ptr > frames_str_buf + frames_buf_capacity);		\
 } while (0)
 
-#define HEADERS_FRAME_END()				\
-	frames[frames_cnt].str = frames_buf_ptr - frame_sz;    \
-	frames[frames_cnt].len = frame_sz;    \
-	frames_total_sz += frame_sz; \
-	frames_max_sz = max(frames_max_sz, frame_sz);	\
-	++frames_cnt; \
+#define HEADERS_FRAME_END()							\
+	BUG_ON(frames_cnt >= ARRAY_SIZE(frames));				\
+	frames[frames_cnt].str = frames_buf_ptr - frame_sz;			\
+	frames[frames_cnt].len = frame_sz;					\
+	frames_total_sz += frame_sz;						\
+	frames_max_sz = max(frames_max_sz, frame_sz);				\
+	++frames_cnt;								\
 } while (0)
 
 
-#define DATA_FRAME_BEGIN()				\
-do {							\
-	unsigned int frame_sz = 0;			\
-	frames[frames_cnt].subtype = HTTP2_DATA	\
+#define DATA_FRAME_BEGIN()							\
+do {										\
+	unsigned int frame_sz = 0;						\
+	BUG_ON(frames_cnt >= ARRAY_SIZE(frames));				\
+	frames[frames_cnt].subtype = HTTP2_DATA					\
 
-#define DATA(data_rec)			\
-do {							\
-	memcpy_fast(frames_buf_ptr, data_rec.buf, data_rec.size); \
-	frames_buf_ptr += data_rec.size; \
-	frame_sz += data_rec.size;			\
-	BUG_ON(frames_buf_ptr > frames_str_buf + frames_buf_capacity);	\
+#define DATA(data_rec)								\
+do {										\
+	memcpy_fast(frames_buf_ptr, data_rec.buf, data_rec.size);		\
+	frames_buf_ptr += data_rec.size;					\
+	frame_sz += data_rec.size;						\
+	BUG_ON(frames_buf_ptr > frames_str_buf + frames_buf_capacity);		\
 } while (0)
 
-#define DATA_FRAME_END()				\
-	frames[frames_cnt].str = frames_buf_ptr - frame_sz;    \
-	frames[frames_cnt].len = frame_sz;    \
-	frames_total_sz += frame_sz; \
-	frames_max_sz = max(frames_max_sz, frame_sz);	\
-	++frames_cnt; \
+#define DATA_FRAME_END()							\
+	BUG_ON(frames_cnt >= ARRAY_SIZE(frames));				\
+	frames[frames_cnt].str = frames_buf_ptr - frame_sz;			\
+	frames[frames_cnt].len = frame_sz;					\
+	frames_total_sz += frame_sz;						\
+	frames_max_sz = max(frames_max_sz, frame_sz);				\
+	++frames_cnt;								\
 } while (0)
 
 
@@ -514,14 +512,20 @@ validate_data_fully_parsed(int type)
 		test_case_parse_prepare_http(str, sz_diff);		\
 	while (TRY_PARSE_EXPECT_PASS(type, chunk_mode))
 
-#define H2_BUILDER_SET_BUF(h2_builder_buf) \
+#define H2_BUILDER_SET_BUF(h2_builder_buf)				\
+	BUG_ON(frames_buf_ptr);						\
 	frames_buf_ptr = h2_builder_buf;				\
-	frames_buf_capacity = sizeof(h2_builder_buf); \
+	frames_buf_capacity = sizeof(h2_builder_buf);			\
 	bzero_fast(frames_buf_ptr, frames_buf_capacity)
 
-#define H2_BUILDER_INIT() \
-	frames_cnt = 0;	\
-	frames_total_sz = 0;	 \
+#define H2_BUILDER_RESET_BUF()						\
+	BUG_ON(!frames_buf_ptr);					\
+	frames_buf_ptr = NULL;						\
+	frames_buf_capacity = 0
+
+#define H2_BUILDER_INIT()						\
+	frames_cnt = 0;							\
+	frames_total_sz = 0;						\
 	frames_max_sz = 0
 
 #define H2_BUILDER_GET_BUF_SIZE() \
@@ -530,16 +534,17 @@ validate_data_fully_parsed(int type)
 #define FOR_REQ(str)							\
 	__FOR_REQ(str, 0, FUZZ_REQ, CHUNK_ON)
 #define FOR_REQ_H2(H2_BUILDER_BLOCK)					\
-	H2_BUILDER_INIT();				\
-	H2_BUILDER_SET_BUF(frames_str_buf);		\
+	H2_BUILDER_INIT();						\
+	H2_BUILDER_SET_BUF(frames_str_buf);				\
 	H2_BUILDER_BLOCK;						\
+	H2_BUILDER_RESET_BUF();						\
 	__FOR_REQ(							\
 	    "HTTP/2 request preview is not available now...",		\
 	     0, FUZZ_REQ_H2, CHUNK_ON)
 #define FOR_REQ_H2_CHUNK_OFF(str)					\
 	__FOR_REQ(str, 0, FUZZ_REQ_H2, CHUNK_OFF)
 
-#define __EXPECT_BLOCK_REQ(str, type, chunk_mode)				\
+#define __EXPECT_BLOCK_REQ(str, type, chunk_mode)			\
 do {									\
 	TEST_LOG("=== request: [%s]\n", str);				\
 	type == FUZZ_REQ_H2 ?						\
@@ -550,10 +555,11 @@ do {									\
 
 #define EXPECT_BLOCK_REQ(str)						\
 	__EXPECT_BLOCK_REQ(str, FUZZ_REQ, CHUNK_ON)
-#define EXPECT_BLOCK_REQ_H2(H2_BUILDER_BLOCK)			\
-	H2_BUILDER_INIT();				\
-	H2_BUILDER_SET_BUF(frames_str_buf);		\
+#define EXPECT_BLOCK_REQ_H2(H2_BUILDER_BLOCK)				\
+	H2_BUILDER_INIT();						\
+	H2_BUILDER_SET_BUF(frames_str_buf);				\
 	H2_BUILDER_BLOCK;						\
+	H2_BUILDER_RESET_BUF();						\
 	__EXPECT_BLOCK_REQ(						\
 	    "HTTP/2 request preview is not available now...",		\
 	    FUZZ_REQ_H2, CHUNK_ON)
@@ -571,10 +577,10 @@ do {									\
 do {									\
 	TEST_LOG("=== response: [%s]\n", str);				\
 	test_case_parse_prepare_http(str, 0);				\
-	while (TRY_PARSE_EXPECT_BLOCK(FUZZ_RESP, CHUNK_ON));	\
+	while (TRY_PARSE_EXPECT_BLOCK(FUZZ_RESP, CHUNK_ON));		\
 } while (0)
 
-#define EXPECT_TFWSTR_EQ(tfw_str, cstr) 			\
+#define EXPECT_TFWSTR_EQ(tfw_str, cstr)					\
 	EXPECT_TRUE(tfw_str_eq_cstr(tfw_str, cstr, strlen(cstr), 0))
 
 /*
